%
% WBHeuristik.pl
%
% interne Wissensbasis fuer die Heuristik
%
% Hier koennen die Werte/Konstanten, die das Programm nutzt,
% geaendert werden.
%

%
% Der groesste moegliche Wert, der vergeben wird, ist 
% 3 000 000.  Dieser Wert wird fuer schon festplatzierte
% Veranstaltungen vergeben.  Ausserdem erhalten 
% Veranstaltungen, deren Teilnehmer besonders eingeschraenkt
% sind, diesen Wert.
% Die naechste Abstufung ist 2 000 000.  Dieser Wert wird
% fuer eine besonders Grosse Anzahl von Teilnehmergruppen
% und Drei- und Vierfachstunden vergeben.
% 1 000 000 wird fuer Doppelstunden vergeben.
%
% Diese Werte sind nicht beeinflussbar bzw. fest codiert, 
% greifen aber nur bei den hoechten Einschraenkungen.

%
% Beeinflussbar sind aber weitere Sortierungen, die bei nicht
% so stark eingeschraenkten Veranstaltungen greifen.  Ueber 
% diese Sortierungen werden die restlichen Veranstaltungen
% gewichtet.
%

/***********************************************************/
/* Dieser Wert findet im System als Subtraktion            */
/* Beruecksichtigung.  Spielraum ist dabei der Zeitraum,   */
/* in dem noch Veranstaltungen platziert werden  koennen.  */
/* Ist ein Teilnehmer so sehr eingeschraenkt, dass         */
/* eigentlich kein Platzierungsspielraum mehr vorhanden    */
/* ist, kommt der Spielraum mit der Zahl 0 ins Spiel.      */
/***********************************************************/
/* Gewichtung is Wert - Spielraum                          */
/***********************************************************/
teilnehmerEinschraenkung(2000).

/***********************************************************/
/* Dieser Wert geht als Division in die Berechnung ein.    */
/* Eine Division ist notwendig, um die Einschraenkungen,   */
/* die maximal 3 000 000 betragen, auf einen "normalen"    */
/* Wert runterzurechnen.  So wird sicher gestellt, dass    */
/* die gefundenen Werte nicht mit den fest codierten       */
/* Werten in Konflikt kommen.                              */
/* Eine Division findet nur statt, wenn mindestens einer   */
/* der Werte (Raum, Tag, Zeit) festgelegt ist.             */
/***********************************************************/
/* Gewichtung is Einschraenkung / Wert                     */
/***********************************************************/
mostConstraint(1000).

/***********************************************************/
/* Dieser Wert wird 1:1 im Programm uebernommen.  Vergeben */
/* wird der Wert, wenn fuer eine Veranstaltung ein fester  */
/* Raum vorgesehen ist.  Dabei ist es unwichtig, ob ein    */
/* Raum oder eine Auswahl von Raeumen angegeben wurde.     */
/***********************************************************/
teilnehmerAnzahl(1000).

/***********************************************************/
/* Geht als Multiplikation bei der Berechnung ein.         */
/* Anzahl ist dabei die Anzahl der gefundenen Teilnehmer-  */
/* gruppen.
/***********************************************************/
/* Gewichtung is AnzahlDerTeilnehmerGruppen * Wert         */
/***********************************************************/
teilnehmerGruppen(100).
