%
% vorverarbeitung.pl
%
% Aufbereitung der Wissensbasis
%

% letzte Aenderung 7.11.01 mb: wandle fr harte u. weiche Einschrnkungen
% Namen in Nummern um

% letzte Aenderung 8.11.01 mb: schreibe leere fail-fakten 
% (z.B.: doppelstundeV(_, _) :- fail.)
% fr die umgeschriebenen harten und weichen Einschrnkungen

% letzte Aenderung 14.11.01 rs: auslesen der urspruenglichen 
% veranstaltungNichtAmUmIn-Fakten in bearbeiteVerNichtAmUmIn(Ausgabe)

% letzte Aenderung 16.11.01 mb: neues Fakt zurGleichenZeit und
% Zulassen von Veranstaltungen in mehrerenHoersaelen gleichzeitig
% mittels und(Raeume) Fakt in den Veranstaltungsressourcen

% letzte Aenderung 20.11.01 rs: bearbeiteVerAmSelbenTag fuer
% bis zu 4 Elemente erweitert

% letzte Aenderung 21.11.01 rs: indizieren von Teilnehmern 
% eingefuegt

% letzte Aenderung 22.11.01 rs: bessere Formatierung der 
% Ausgabedatei eingebaut

% letzte Aenderung 4.2.02 rs: Ausgaben in Stream durch writeq
% ersetzt, an gleicheTeilnehmer ein :- false angehaengt

/***********************************************************/
/* vorverarbeitung(+Ausgabe, ?Array)                       */
/***********************************************************/
/* Steuern der Vorverarbeitung                             */
/***********************************************************/
vorverarbeitung(Ausgabe, Stundenplan) :-
	writeln("Starte Verarbeitung ..."),
	initAusgabe(Ausgabe),
	writeln("Verarbeiten der Stammdaten ..."),
	bearbeiteStammdaten(Ausgabe),
	writeln("Verarbeiten der Vorlesungsdaten ..."),
	compile(Ausgabe),
	bearbeiteVorlesungsdaten(Ausgabe),
	writeln("Erstellen der Arbeitsstruktur ... "),
	erstelleArray(Stundenplan),
	writeln("Vorverarbeitung erfolgreich abgeschlossen!").

/***********************************************************/
/* initAusgabe(+Ausgabedatei)                              */
/***********************************************************/
/* Initialisieren der Ausgabedatei                         */ 
/***********************************************************/
initAusgabe(Ausgabe) :-
	open(Ausgabe, write, Stream),
	print(Stream, '% Ergebnis der Vorverarbeitung.'),
        nl(Stream),  
	nl(Stream),  
	close(Stream).

/***********************************************************/
/* bearbeiteStammdaten(+Ausgabedatei)                      */
/***********************************************************/
/* Aufbereiten der Ausgangs-Wissensbasis                   */
/***********************************************************/
bearbeiteStammdaten(Ausgabe) :-
	findall(raum(RaumName, RaumGroesse, RaumRessourcen, RaumKosten), raum(RaumName, RaumGroesse, RaumRessourcen, RaumKosten), NeueRaumListe),
	schreibeNumListe(NeueRaumListe, Ausgabe),  
	findall(tag(Tagname, TagKosten), tag(Tagname, TagKosten), NeueTagListe),
	schreibeNumListe(NeueTagListe, Ausgabe),    
	findall(zeit(Zeitname, ZeitKosten), zeit(Zeitname, ZeitKosten), NeueZeitListe),
	schreibeNumListe(NeueZeitListe, Ausgabe),
	erstelleRaumListe(RaumListe),
	erstelleTagListe(TagesListe),
	erstelleZeitListe(ZeitenListe),
	length(RaumListe, AnzRaeume),
	length(TagesListe, AnzTage),
	length(ZeitenListe, AnzZeiten),
	schreibeAnzahlen(AnzRaeume, AnzTage, AnzZeiten, Ausgabe),
	findall(teilnehmer(TeilName, TeilNAnzahl), teilnehmer(TeilName, TeilNAnzahl), TeilNListe),
	schreibeTeilnehmer(TeilNListe, Ausgabe),
	dozenten(DozListe),
	dozentenInTeilnehmer(DozListe, Ausgabe),
	compile(Ausgabe),
	findall(teilnehmer(Name, Anzahl), teilnehmerN(Name, Anzahl), GTeilNListe),
	findall(teilnehmer(Name, 0), untergruppe(Name, _, _), UntergruppenListe1),
	sort(UntergruppenListe1, UntergruppenListe),
	schreibeTeilnehmer(UntergruppenListe, Ausgabe),
	indiziereTeilnehmer(GTeilNListe, Ausgabe).

/***********************************************************/
/* schreibeAnzahlen(+AnzRaeume, +AnzTage, +AnzZeiten,      */
/*      +Ausgabedatei)                                     */
/***********************************************************/
/* Schreiben der Anzahlen in die Ausgabedatei              */
/***********************************************************/
schreibeAnzahlen(AnzRaeume, AnzTage, AnzZeiten, Ausgabe) :-
	open(Ausgabe, append, Stream),
	print(Stream, 'anzTage('),
	print(Stream, AnzTage),
	print(Stream, ').'),
	nl(Stream),
	print(Stream, 'anzZeiten('),
	print(Stream, AnzZeiten),
	print(Stream, ').'),
	nl(Stream),
	print(Stream, 'anzRaeume('),
	print(Stream, AnzRaeume),
	print(Stream, ').'),
	nl(Stream),
	nl(Stream),
	close(Stream).

/***********************************************************/
/* schreibeTeilnehmer(+Studenten, +Ausgabedatei)           */
/***********************************************************/
/* Schreiben der Teilnehmer in die Ausgabedatei            */
/***********************************************************/
schreibeTeilnehmer(Liste, Ausgabe) :-
	open(Ausgabe, append, Stream),
	schreibeTeilnehmer1(Liste, Stream),  
	close(Stream).

/***********************************************************/
/* schreibeTeilnehmer1(+Studenten, ?Ausgabedatei)          */
/***********************************************************/
/* Hinzufuegen der Studenten mit der aktuellen Anzahl      */
/***********************************************************/
schreibeTeilnehmer1([], Stream) :-
	nl(Stream).
schreibeTeilnehmer1([teilnehmer(TeilnName, Anzahl)|Rest], Stream) :-
	print(Stream, 'teilnehmerN('),  
	print(Stream, TeilnName),  
	print(Stream, ', '),
	print(Stream, Anzahl),
	print(Stream, ').'),
	nl(Stream),
	schreibeTeilnehmer1(Rest, Stream). 

/***********************************************************/
/* dozentenInTeilnehmer(+Dozenten, +Ausgabedatei)          */
/***********************************************************/
/* Aufbereiten der Dozentendaten aus der Wissensbasis      */
/***********************************************************/
dozentenInTeilnehmer(Liste, Ausgabe) :-
	open(Ausgabe, append, Stream),
	dozentenInTeilnehmer1(Liste, Stream),  
	close(Stream).

/***********************************************************/
/* dozentenInTeilnehmer1(+Dozenten, +Ausgabedatei)         */
/***********************************************************/
/* Schreiben der Dozenten in die Ausgabedatei              */
/* Hinzufuegen zur Teilnehmerliste (Anzahl 0)              */
/***********************************************************/
dozentenInTeilnehmer1([], Stream) :-
	nl(Stream).
dozentenInTeilnehmer1([Kopf|Rest], Stream) :-
	print(Stream, 'teilnehmerN('),    
	print(Stream, Kopf),  
	print(Stream, ', 0).'),
	nl(Stream),
	dozentenInTeilnehmer1(Rest, Stream). 

/***********************************************************/
/* indiziereTeilnehmer(+Teilnehmer, +Ausgabedatei)         */
/***********************************************************/
/* Schreiben der Teillnehmer in die Ausgabedatei.          */
/* Hinzufuegen eines Indizes.                              */
/***********************************************************/
indiziereTeilnehmer(Liste, Ausgabe) :-
	open(Ausgabe, append, Stream),
	indiziereTeilnehmer1(Liste, 1, Stream),  
	nl(Stream),
	close(Stream).

/***********************************************************/
/* indiziereTeilnehmer1(+Teilnehmer, +Index, +Stream)      */
/***********************************************************/
indiziereTeilnehmer1([], _, _).
indiziereTeilnehmer1([teilnehmer(Name, Anzahl)|Rest], Index, Stream) :-
	print(Stream, 'teilnehmer('),    
	print(Stream, Index),
	print(Stream, ', '),
	print(Stream, Name),  
	print(Stream, ', '),
	print(Stream, Anzahl),
	print(Stream, ').'),
	nl(Stream),
	IndexNeu is Index + 1,
	indiziereTeilnehmer1(Rest, IndexNeu, Stream). 
	
/***********************************************************/
/* bearbeiteVorlesungsdaten(+Ausgabedatei)                 */
/***********************************************************/
/* Aufbereitung der Vorlesungsinformationen.               */
/***********************************************************/
bearbeiteVorlesungsdaten(Ausgabe) :-
	findall(veranstaltung(VerName, VerTeil, VerRes), veranstaltung(VerName, VerTeil, VerRes), NeuVerListe),
	schreibeNumListe1(NeuVerListe, Ausgabe, ZurGleichenZeitListe), 
        compile(Ausgabe),
	findall(VerNr, veranstaltung(VerNr, _, _, _, _), VerListe),
	length(VerListe, AnzVeranst),
	schreibeAnzahlen(AnzVeranst, Ausgabe),
	schreibeProblemVars(VerListe, Ausgabe),
	findeGleicheTeilnehmerGruppen(Ausgabe),
        bearbeiteZurGleichenZeitListe(ZurGleichenZeitListe, Ausgabe),
	bearbeiteHarteConstr(Ausgabe),
	bearbeiteWuensche(Ausgabe).

/***********************************************************/
/* bearbeiteHarteConstr(+Ausgabedatei)                     */
/***********************************************************/
/* Umschreiben der harten Constr: Namen -> Nummern         */
/***********************************************************/
bearbeiteHarteConstr(Ausgabe) :-
	% hier erst die alten veranstaltungNichtAmUmIn einlesen....
	findall((Name, TagesListe, ZeitenListe, Raum), veranstaltungNichtAmUmIn(Name, TagesListe, ZeitenListe, Raum), NichtAmUmInAlt),
	% hier erst die alten veranstaltungAmUmIn einlesen....
	findall((Name, TagesListe, ZeitenListe, Raum), veranstaltungAmUmIn(Name, TagesListe, ZeitenListe, Raum), AmUmInAlt),
	bearbeiteDoppelstunden(Ausgabe),
	bearbeiteNichtAmSelbenTag(Ausgabe),
	bearbeiteTeilNichtAmUm(Ausgabe),
	compile(Ausgabe), 
	bearbeiteVerAmUmIn(AmUmInAlt, Ausgabe),
	bearbeiteVerNichtAmUmIn(NichtAmUmInAlt, Ausgabe),
	bearbeiteVerNichtZusammenhaengend(Ausgabe),
	bearbeiteVerAmSelbenTag(Ausgabe).

/***********************************************************/
/* bearbeiteWuensche(+Ausgabedatei)                        */
/***********************************************************/
/* Umschreiben der weichen Constr: Namen -> Nummern        */
/***********************************************************/
bearbeiteWuensche(Ausgabe) :-
	bearbeiteWDoppelstunden(Ausgabe),
	bearbeiteWNichtAmSelbenTag(Ausgabe),
	bearbeiteWTeilNichtAmUm(Ausgabe),
	bearbeiteWVerNichtAmUmIn(Ausgabe),
	bearbeiteWVerAmUmIn(Ausgabe),
	bearbeiteWVerNichtZusammenhaengend(Ausgabe),
	bearbeiteWVerAmSelbenTag(Ausgabe).

/***********************************************************/
/* bearbeiteZurGleichenZeitListe(+ZurGleichenZeitListe,    */
/*     +Ausgabe)                                           */
/***********************************************************/
/* Schreiben der zurGleichenZeitConstraints                */
/***********************************************************/
bearbeiteZurGleichenZeitListe(ZurGleichenZeitListe, Ausgabe) :- 
	open(Ausgabe, append, Stream),
	bearbeiteZurGleichenZeitListe1(ZurGleichenZeitListe, Stream),
	close(Stream).

/***********************************************************/
/* bearbeiteZurGleichenZeitListe1(+ZurGleichenZeitListe,   */
/*     +Stream)                                            */
/***********************************************************/
bearbeiteZurGleichenZeitListe1([], Stream) :-
	print(Stream, 'zurGleichenZeitV('),
	print(Stream, '_'),
	print(Stream, ', '),
	print(Stream, '_'),
	print(Stream, ') :- false.'),
	nl(Stream),
	nl(Stream).
bearbeiteZurGleichenZeitListe1([Kopf|Rest], Stream) :-
	bearbeiteZurGleichenZeitListe2(Kopf, Stream),
	bearbeiteZurGleichenZeitListe1(Rest, Stream).

/***********************************************************/
/* bearbeiteZurGleichenZeitListe2(+Element, +Stream)       */
/***********************************************************/
bearbeiteZurGleichenZeitListe2([], _) :-
	!.
bearbeiteZurGleichenZeitListe2([_], _) :-
	!.
bearbeiteZurGleichenZeitListe2([Ele1, Ele2], Stream) :-
	print(Stream, 'zurGleichenZeitV('),
	print(Stream, Ele1),
	print(Stream, ', '),
	print(Stream, Ele2),
	print(Stream, ').'),
	nl(Stream),
	!.
bearbeiteZurGleichenZeitListe2([Ele1, Ele2|Rest], Stream) :-
	print(Stream, 'zurGleichenZeitV('),
	print(Stream, Ele1),
	print(Stream, ', '),
	print(Stream, Ele2),
	print(Stream, ').'),
	nl(Stream),
	bearbeiteZurGleichenZeitListe2([Ele2|Rest], Stream).

/***********************************************************/
/* schreibeAnzahlen(+AnzVeranst, +Ausgabedatei)            */
/***********************************************************/
/* Schreiben der Anzahl der Aeranstaltungen in die         */
/* Ausgabedatei                                            */
/***********************************************************/
schreibeAnzahlen(AnzVeranst, Ausgabe) :-
	open(Ausgabe, append, Stream),
	print(Stream, 'anzVeranst('),
	print(Stream, AnzVeranst),
	print(Stream, ').'),
	nl(Stream),
	nl(Stream),
	close(Stream).    

/***********************************************************/
/* schreibeProblemVars(+Veranstaltungen, +Ausgabedatei)    */
/***********************************************************/
/* Anlegen der Struktur, aus der das Array erstellt wird   */
/***********************************************************/
schreibeProblemVars(NeuVerListe, Ausgabe) :-
	open(Ausgabe, append, Stream),
	schreibeProblemVars(NeuVerListe, -1, Stream),
	close(Stream).

/***********************************************************/
/* schreibeProblemVars(+Veranstaltungen, +Zaehler,         */
/*          +Ausgabedatei)                                 */
/***********************************************************/
/* Aufbau der Grundstruktur des zu verwendenden Arrays     */
/***********************************************************/
schreibeProblemVars([], _, Stream) :-
	print(Stream, ')).'),   
	nl(Stream),
	nl(Stream).
schreibeProblemVars([_|Rest], -1, Stream) :-
	print(Stream, 'einStundenplan('),
	print(Stream, 'stundenplan('),
	schreibeProblemVars([_|Rest], 0, Stream).
schreibeProblemVars([_], NumOld, Stream) :-
	Num is NumOld + 1,
	print(Stream, 'ver('),
	print(Stream, 'Raum'),
	print(Stream, Num),
	print(Stream, ', '),
	print(Stream, 'Tag'),
	print(Stream, Num),
	print(Stream, ', '),
	print(Stream, 'Zeit'),
	print(Stream, Num),
	print(Stream, ')'),
	schreibeProblemVars([], Num, Stream).
schreibeProblemVars([_|Rest], NumOld, Stream) :-
	Num is NumOld + 1,
	print(Stream, 'ver('),
	print(Stream, 'Raum'),
	print(Stream, Num),
	print(Stream, ', '),
	print(Stream, 'Tag'),
	print(Stream, Num),
	print(Stream, ', '),
	print(Stream, 'Zeit'),
	print(Stream, Num),
	print(Stream, '), '),
	schreibeProblemVars(Rest, Num, Stream).

/***********************************************************/
/* bearbeiteDoppelstunden(+AusgabeDatei)                   */
/***********************************************************/
/* Umwandlen aller Mehrfachstunden in Doppelstunden        */
/***********************************************************/
bearbeiteDoppelstunden(Ausgabe) :-
	findall((Name1, Name2), doppelstunde(Name1, Name2), DoppelstundenListe),
	findall((Name1, Name2), dreifachstunde(Name1, Name2, _), DreifachstundenListe1),
	findall((Name2, Name3), dreifachstunde(_, Name2, Name3), DreifachstundenListe2),
	findall((Name1, Name2), vierfachstunde(Name1, Name2, _, _), VierfachstundenListe1),
	findall((Name2, Name3), vierfachstunde(_, Name2, Name3, _), VierfachstundenListe2),
	findall((Name3, Name4), vierfachstunde(_, _, Name3, Name4), VierfachstundenListe3),
	append(DoppelstundenListe, DreifachstundenListe1, HilfsListe1),
	append(HilfsListe1, DreifachstundenListe2, HilfsListe2),
	append(HilfsListe2, VierfachstundenListe1, HilfsListe3),
	append(HilfsListe3, VierfachstundenListe2, HilfsListe4),
	append(HilfsListe4, VierfachstundenListe3, Liste),
	schreibeZweiVer(Liste, Ausgabe, 'doppelstundeV').

/***********************************************************/
/* bearbeiteNichtAmSelbenTag(+AusgabeDatei)                */
/***********************************************************/
/* Umwandlen der veranstaltungenNichtAmSelbenTag-          */
/* Einschraenkungen (/2, /3, /4) in /2-Einschraenkungen.   */
/***********************************************************/
bearbeiteNichtAmSelbenTag(Ausgabe) :-
	findall((Name1, Name2), veranstaltungenNichtAmSelbenTag(Name1, Name2), 
Liste1),
	findall((Name1, Name2), (veranstaltungenNichtAmSelbenTag(Name1, Name2, Namea), not(number(Namea))), Liste2),
	findall((Name1, Name2), (veranstaltungenNichtAmSelbenTag(Name1, _, Name2), not(number(Name2))), Liste3),
	findall((Name1, Name2), (veranstaltungenNichtAmSelbenTag(_, Name1, Name2), not(number(Name2))), Liste4),
	findall((Name1, Name2), (veranstaltungenNichtAmSelbenTag(Name1, Name2, _, Nameb), not(number(Nameb))), Liste5),
	findall((Name1, Name2), (veranstaltungenNichtAmSelbenTag(Name1, _, Name2, Namec), not(number(Namec))), Liste6),
	findall((Name1, Name2), (veranstaltungenNichtAmSelbenTag(Name1, _, _, Name2), not(number(Name2))), Liste7),
	findall((Name1, Name2), (veranstaltungenNichtAmSelbenTag(_, Name1, Name2, Named), not(number(Named))), Liste8),
	findall((Name1, Name2), (veranstaltungenNichtAmSelbenTag(_, Name1, _, Name2), not(number(Name2))), Liste9),
	findall((Name1, Name2), (veranstaltungenNichtAmSelbenTag(_, _, Name1, Name2), not(number(Name2))), Liste10),
	append(Liste1, Liste2, HilfsListe1),
	append(HilfsListe1, Liste3, HilfsListe2),
	append(HilfsListe2, Liste4, HilfsListe3),
	append(HilfsListe3, Liste5, HilfsListe4),
	append(HilfsListe4, Liste6, HilfsListe5),
	append(HilfsListe5, Liste7, HilfsListe6),
	append(HilfsListe6, Liste8, HilfsListe7),
	append(HilfsListe7, Liste9, HilfsListe8),
	append(HilfsListe8, Liste10, Liste),
	schreibeZweiVer(Liste, Ausgabe, 'veranstaltungenNichtAmSelbenTagV').

/***********************************************************/
/* bearbeiteTeilNichtAmUm(+Ausgabedatei)                   */
/***********************************************************/
/* teilnehmerNichtAmUm umschreiben in                      */
/* veranstaltung(Nicht)AmUmIn.                             */
/* Gibt es nur Einschraenkungen in Am oder Um werden die   */
/* Veranstaltungen des Teilnehmers in veranstaltungAmUmIn  */
/* umgeschrieben.  Diese wiegen bei spaeteren Berechnungen */
/* schwerer.                                               */
/* Gibt es Einschraenkungen in beiden Dimensionen wird     */
/* veranstaltungNichtAmUmIn beschrieben.                   */
/***********************************************************/
bearbeiteTeilNichtAmUm(Ausgabe) :-
	open(Ausgabe, append, Stream),
	findall((Name, TagesListe, ZeitenListe), teilnehmerNichtAmUm(Name, TagesListe, ZeitenListe), Liste),
	bearbeiteTeilNichtAmUmOhneTage(Liste, Stream),
	nl(Stream),
	bearbeiteTeilNichtAmUmOhneZeiten(Liste, Stream),
	nl(Stream),
	bearbeiteTeilNichtAmUmNormal(Liste, Stream),
	nl(Stream),
	close(Stream).

/***********************************************************/
/* bearbeiteTeilNichtAmUmOhneTage(+TeilnehmerListe,        */
/*	+Stream)                                           */
/***********************************************************/
/* teilnehmerNichtAmUm umschreiben in                      */
/* veranstaltungNichtAmUmIn                                */
/***********************************************************/
bearbeiteTeilNichtAmUmOhneTage([], _).
bearbeiteTeilNichtAmUmOhneTage([(Teilnehmer, [], ZeitenListe)|Rest], Stream) :-
	findall(Name, (veranstaltung(_, Name, TeilnehmerMenge, _, _), memberchk(Teilnehmer, TeilnehmerMenge)), VerListe),
	erstelleZeitListe(ZeitListeGesamt),
	subtract(ZeitListeGesamt, ZeitenListe, ZeitenListeNeu),
	bearbeiteTeilNichtAmUm2(VerListe, [], ZeitenListeNeu, Stream),
	bearbeiteTeilNichtAmUmOhneTage(Rest, Stream).
bearbeiteTeilNichtAmUmOhneTage([_|Rest], Stream) :-
	bearbeiteTeilNichtAmUmOhneTage(Rest, Stream).

/***********************************************************/
/* bearbeiteTeilNichtAmUmOhneZeiten(+TeilnehmerListe,      */
/*	+Stream)                                           */
/***********************************************************/
/* Formatiertes Schreiben der Teilnehmer in Stream.        */
/* Dazu werden die Teilnehmerverfgbarkeiten auf           */
/* Veranstaltungen umgerechnet.                            */
/***********************************************************/
bearbeiteTeilNichtAmUmOhneZeiten([], Stream) :-
	print(Stream, 'veranstaltungAmUmIn(_, _, _, _) :- false.'),
	nl(Stream).
bearbeiteTeilNichtAmUmOhneZeiten([(Teilnehmer, TagesListe, [])|Rest], Stream) :-
	findall(Name, (veranstaltung(_, Name, TeilnehmerMenge, _, _), memberchk(Teilnehmer, TeilnehmerMenge)), VerListe),
	erstelleTagListe(TagListeGesamt),
	subtract(TagListeGesamt, TagesListe, TagesListeNeu),
	bearbeiteTeilNichtAmUm2(VerListe, TagesListeNeu, [], Stream),
	bearbeiteTeilNichtAmUmOhneZeiten(Rest, Stream).
bearbeiteTeilNichtAmUmOhneZeiten([_|Rest], Stream) :-
	bearbeiteTeilNichtAmUmOhneZeiten(Rest, Stream).

/***********************************************************/
/* bearbeiteTeilNichtAmUmNormal(+TeilnehmerListe, +Stream) */
/***********************************************************/
/* Formatiertes Schreiben der Teilnehmer in Stream.        */
/* Dazu werden die Teilnehmerverfgbarkeiten auf           */
/* Veranstaltungen umgerechnet.                            */
/***********************************************************/
bearbeiteTeilNichtAmUmNormal([], Stream) :-
	print(Stream, 'veranstaltungNichtAmUmIn(_, _, _, _) :- false.'),
	nl(Stream).
bearbeiteTeilNichtAmUmNormal([(_, TagesListe, ZeitenListe)|Rest], Stream) :-
	(
	    (TagesListe = [])
	;
	    (ZeitenListe = [])
	),
	bearbeiteTeilNichtAmUmNormal(Rest, Stream).
bearbeiteTeilNichtAmUmNormal([(Teilnehmer, TagesListe, ZeitenListe)|Rest], Stream) :-
	findall(Name, (veranstaltung(_, Name, TeilnehmerMenge, _, _), memberchk(Teilnehmer, TeilnehmerMenge)), VerListe),
	bearbeiteTeilNichtAmUm2(VerListe, TagesListe, ZeitenListe, Stream), 
	bearbeiteTeilNichtAmUmNormal(Rest, Stream).

/***********************************************************/
/* bearbeiteTeilNichtAmUm2(+VeranstaltungsListe,           */
/*      +TagesListe, +ZeitenListe, +Stream)                */
/***********************************************************/
/* teilnehmerNichtAmUm umschreiben in                      */
/* veranstaltungNichtAmUmIn                                */
/***********************************************************/
bearbeiteTeilNichtAmUm2([], _, _, _).
bearbeiteTeilNichtAmUm2([Kopf|Rest], TagesListe, ZeitenListe, Stream) :-
	schreibeTeilNichtAmUm((Kopf, TagesListe, ZeitenListe), Stream),
	bearbeiteTeilNichtAmUm2(Rest, TagesListe, ZeitenListe, Stream).

/***********************************************************/
/* schreibeTeilNichtAmUm(+(Veranstaltung, TagesListe,      */
/*      ZeitenListe), +Stream)                             */
/***********************************************************/
/* teilnehmerNichtAmUm umschreiben in                      */
/* veranstaltungNichtAmUmIn                                */
/***********************************************************/
schreibeTeilNichtAmUm((Kopf, [], ZeitenListe), Stream) :-
	print(Stream, 'veranstaltungAmUmIn(\''),
	print(Stream, Kopf),
	print(Stream, '\', '),
	print(Stream, '_'),
	print(Stream, ', '),
	schreibeNormListe(Stream, ZeitenListe),
	print(Stream, ', '),
	print(Stream, '_'),
	print(Stream, '). '),
	nl(Stream).
schreibeTeilNichtAmUm((Kopf, TagesListe, []), Stream) :-
	print(Stream, 'veranstaltungAmUmIn(\''),
	print(Stream, Kopf),
	print(Stream, '\', '),
	schreibeNormListe(Stream, TagesListe),
	print(Stream, ', '),
	print(Stream, '_'),
	print(Stream, ', '),
	print(Stream, '_'),
	print(Stream, '). '),
	nl(Stream).
schreibeTeilNichtAmUm((Kopf, TagesListe, ZeitenListe), Stream) :-
	print(Stream, 'veranstaltungNichtAmUmIn(\''),
	print(Stream, Kopf),
	print(Stream, '\', '),
	schreibeNormListe(Stream, TagesListe),
	print(Stream, ', '),
	schreibeNormListe(Stream, ZeitenListe),
	print(Stream, ', '),
	print(Stream, '_'),
	print(Stream, '). '),
	nl(Stream).

/***********************************************************/
/* bearbeiteVerNichtAmUmIn(+Liste, -Ausgabedatei)          */
/***********************************************************/
/* Namen in Nummern umwandeln fuer                         */
/* veranstaltungNichtAmUmIn                                */
/***********************************************************/
bearbeiteVerNichtAmUmIn(Liste, Ausgabe) :-
	findall((Name, TagesListe, ZeitenListe, Raum), veranstaltungNichtAmUmIn(Name, TagesListe, ZeitenListe, Raum), NichtAmUmInNeu),
	append(Liste, NichtAmUmInNeu, NichtAmUmIn),
	bearbeiteVerNichtAmUmIn1(NichtAmUmIn, Ausgabe).

/***********************************************************/
/* bearbeiteVerNichtAmUmIn1(+Liste, -Ausgabe)              */
/***********************************************************/
bearbeiteVerNichtAmUmIn1([(Name, [], ZeitenListe, Raum)|Rest], Ausgabe) :-
	erstelleZeitListe(ZeitListeGesamt),
	subtract(ZeitListeGesamt, ZeitenListe, ZeitenListeNeu),
	schreibeVerMitZeitHilf([(Name, _, ZeitenListeNeu, Raum)], Ausgabe, 'veranstaltungAmUmInV'),
	bearbeiteVerNichtAmUmIn1(Rest, Ausgabe).
bearbeiteVerNichtAmUmIn1([(Name, TagesListe, [], Raum)|Rest], Ausgabe) :-
	erstelleTagListe(TagListeGesamt),
	subtract(TagListeGesamt, TagesListe, TagesListeNeu),
	schreibeVerMitZeitHilf([(Name, TagesListeNeu, _, Raum)], Ausgabe, 'veranstaltungAmUmInV'),
	bearbeiteVerNichtAmUmIn1(Rest, Ausgabe).
bearbeiteVerNichtAmUmIn1(Liste, Ausgabe) :-
	schreibeVerMitZeit(Liste, Ausgabe, 'veranstaltungNichtAmUmInV').

/***********************************************************/
/* bearbeiteVerAmUmIn(+Liste, -Ausgabedatei)               */
/***********************************************************/
/* Namen in Nummern umwandeln fuer veranstaltungAmUmIn     */
/***********************************************************/
bearbeiteVerAmUmIn(Liste, Ausgabe) :-
	findall((Name, TagesListe, ZeitenListe, Raum), veranstaltungAmUmIn(Name, TagesListe, ZeitenListe, Raum), AmUmInListeNeu),
	append(Liste, AmUmInListeNeu, AmUmInListe),
	schreibeVerMitZeit(AmUmInListe, Ausgabe, 'veranstaltungAmUmInV').
   
/***********************************************************/
/* bearbeiteVerNichtZusammenhaengend(+Ausgabedatei)        */
/***********************************************************/
/* Namen in Nummern umwandeln fuer                         */
/* veranstaltungenNichtZusammenhaengend                    */
/***********************************************************/
bearbeiteVerNichtZusammenhaengend(Ausgabe) :-
	findall((Name1, Name2), veranstaltungenNichtZusammenhaengend(Name1, Name2), Liste),
	schreibeZweiVer(Liste, Ausgabe, 'veranstaltungenNichtZusammenhaengendV'). 

/***********************************************************/
/* bearbeiteVerAmSelbenTag(+Ausgabedatei)                  */
/***********************************************************/
/* Namen in Nummern umwandeln fuer                         */
/* veranstaltungenAmSelbenTag                              */
/***********************************************************/
bearbeiteVerAmSelbenTag(Ausgabe) :-
	findall((Name1, Name2), veranstaltungenAmSelbenTag(Name1, Name2), Liste1),
	findall((Name1, Name2), (veranstaltungenAmSelbenTag(Name1, Name2, Namea), not(number(Namea))), Liste2),
	findall((Name1, Name2), (veranstaltungenAmSelbenTag(Name1, _, Name2), not(number(Name2))), Liste3),
	findall((Name1, Name2), (veranstaltungenAmSelbenTag(_, Name1, Name2), not(number(Name2))), Liste4),
	findall((Name1, Name2), (veranstaltungenAmSelbenTag(Name1, Name2, _, Nameb), not(number(Nameb))), Liste5),
	findall((Name1, Name2), (veranstaltungenAmSelbenTag(Name1, _, Name2, Namec), not(number(Namec))), Liste6),
	findall((Name1, Name2), (veranstaltungenAmSelbenTag(Name1, _, _, Name2), not(number(Name2))), Liste7),
	findall((Name1, Name2), (veranstaltungenAmSelbenTag(_, Name1, Name2, Named), not(number(Named))), Liste8),
	findall((Name1, Name2), (veranstaltungenAmSelbenTag(_, Name1, _, Name2), not(number(Name2))), Liste9),
	findall((Name1, Name2), (veranstaltungenAmSelbenTag(_, _, Name1, Name2), not(number(Name2))), Liste10),
	append(Liste1, Liste2, HilfsListe1),
	append(HilfsListe1, Liste3, HilfsListe2),
	append(HilfsListe2, Liste4, HilfsListe3),
	append(HilfsListe3, Liste5, HilfsListe4),
	append(HilfsListe4, Liste6, HilfsListe5),
	append(HilfsListe5, Liste7, HilfsListe6),
	append(HilfsListe6, Liste8, HilfsListe7),
	append(HilfsListe7, Liste9, HilfsListe8),
	append(HilfsListe8, Liste10, Liste),
	schreibeZweiVer(Liste, Ausgabe, 'veranstaltungenAmSelbenTagV').

/***********************************************************/
/* bearbeiteZurGleichenZeit(+Ausgabedatei)                 */
/***********************************************************/
/* Namen in Nummern umwandeln fuer zurGleichenZeit         */
/***********************************************************/
bearbeiteZurGleichenZeit(Ausgabe) :-
	findall((Name1, Name2), zurGleichenZeit(Name1, Name2), Liste),
	schreibeZweiVer(Liste, Ausgabe, 'zurGleichenZeitV').    

/***********************************************************/
/* die Wuensche                                            */
/***********************************************************/

/***********************************************************/
/* bearbeiteWDoppelstunden(+Ausgabe)                       */
/***********************************************************/
/* Namen in Nummern umwandeln fuer Mehrfachstunden         */
/***********************************************************/
bearbeiteWDoppelstunden(Ausgabe) :-
	findall((Name1, Name2, Prio1), doppelstunde(Name1, Name2, Prio1), DoppelstundenListe),
	findall((Name1, Name2, Prio2), dreifachstunde(Name1, Name2, _, Prio2), DreifachstundenListe1),
	findall((Name2, Name3, Prio3), dreifachstunde(_, Name2, Name3, Prio3), DreifachstundenListe2),
	findall((Name1, Name2, Prio4), vierfachstunde(Name1, Name2, _, _, Prio4), VierfachstundenListe1),
	findall((Name2, Name3, Prio5), vierfachstunde(_, Name2, Name3, _, Prio5), VierfachstundenListe2),
	findall((Name3, Name4, Prio6), vierfachstunde(_, _, Name3, Name4, Prio6), VierfachstundenListe3),
	append(DoppelstundenListe, DreifachstundenListe1, HilfsListe1),
	append(HilfsListe1, DreifachstundenListe2, HilfsListe2),
	append(HilfsListe2, VierfachstundenListe1, HilfsListe3),
	append(HilfsListe3, VierfachstundenListe2, HilfsListe4),
	append(HilfsListe4, VierfachstundenListe3, Liste),
	schreibeZweiVerPrio(Liste, Ausgabe, 'doppelstundeW').

/***********************************************************/
/* bearbeiteWNichtAmSelbenTag(+Ausgabe)                    */
/***********************************************************/
/* Namen in Nummern umwandeln fuer                         */
/* veranstaltungenNichtAmSelbenTag                         */
/***********************************************************/
bearbeiteWNichtAmSelbenTag(Ausgabe) :-
	findall((Name1, Name2, Prio1), (veranstaltungenNichtAmSelbenTag(Name1, Name2, Prio1), number(Prio1)), Liste1),
	findall((Name1, Name2, Prio2), (veranstaltungenNichtAmSelbenTag(Name1, Name2, _, Prio2), number(Prio2)), Liste2),
	findall((Name1, Name2, Prio3), (veranstaltungenNichtAmSelbenTag(Name1, _, Name2, Prio3), number(Prio3)), Liste3),
	findall((Name1, Name2, Prio4), (veranstaltungenNichtAmSelbenTag(_, Name1, Name2, Prio4), number(Prio4)), Liste4),
	findall((Name1, Name2, Prio5), (veranstaltungenNichtAmSelbenTag(Name1, Name2, _, _, Prio5), number(Prio5)), Liste5),
	findall((Name1, Name2, Prio6), (veranstaltungenNichtAmSelbenTag(Name1, _, Name2, _, Prio6), number(Prio6)), Liste6),
	findall((Name1, Name2, Prio7), (veranstaltungenNichtAmSelbenTag(Name1, _, _, Name2, Prio7), number(Prio7)), Liste7),
	findall((Name1, Name2, Prio8), (veranstaltungenNichtAmSelbenTag(_, Name1, Name2, _, Prio8), number(Prio8)), Liste8),
	findall((Name1, Name2, Prio9), (veranstaltungenNichtAmSelbenTag(_, Name1, _, Name2, Prio9), number(Prio9)), Liste9),
	findall((Name1, Name2, Prio10), (veranstaltungenNichtAmSelbenTag(_, _, Name1, Name2, Prio10), number(Prio10)), Liste10),
	append(Liste1, Liste2, HilfsListe1),
	append(HilfsListe1, Liste3, HilfsListe2),
	append(HilfsListe2, Liste4, HilfsListe3),
	append(HilfsListe3, Liste5, HilfsListe4),
	append(HilfsListe4, Liste6, HilfsListe5),
	append(HilfsListe5, Liste7, HilfsListe6),
	append(HilfsListe6, Liste8, HilfsListe7),
	append(HilfsListe7, Liste9, HilfsListe8),
	append(HilfsListe8, Liste10, Liste),
	schreibeZweiVerPrio(Liste, Ausgabe, 'veranstaltungenNichtAmSelbenTagW').

/***********************************************************/
/* bearbeiteWTeilNichtAmUm(+Ausgabe)                       */
/***********************************************************/
/* Namen in Nummern umwandeln fuer teilnehmerNichtAmUm     */
/***********************************************************/
bearbeiteWTeilNichtAmUm(Ausgabe) :-
	open(Ausgabe, append, Stream),
	findall((Name, TagesListe, ZeitenListe, Prio), teilnehmerNichtAmUm(Name, TagesListe, ZeitenListe, Prio), Liste),
	bearbeiteWTeilNichtAmUm1(Liste, Stream),
	close(Stream).

/***********************************************************/
/* bearbeiteWTeilNichtAmUm1(+Liste, +Stream)               */
/***********************************************************/
bearbeiteWTeilNichtAmUm1([], _).
bearbeiteWTeilNichtAmUm1([(Teilnehmer, TagesListe, ZeitenListe, Prio)|Rest], 
Stream) :-
	findall(Name, (veranstaltung(_, Name, TeilnehmerMenge, _, _), memberchk(Teilnehmer, TeilnehmerMenge)), VerListe),
	bearbeiteWTeilNichtAmUm2(VerListe, TagesListe, ZeitenListe, Prio, Stream), 
	bearbeiteWTeilNichtAmUm1(Rest, Stream).

/***********************************************************/
/* bearbeiteWTeilNichtAmUm2(+Liste, +Tage, +Zeiten, +Prio, */
/*      +Stream)                                           */
/***********************************************************/
bearbeiteWTeilNichtAmUm2([], _, _, _, _).
bearbeiteWTeilNichtAmUm2([Kopf|Rest], TagesListe, ZeitenListe, Prio, Stream) :-   
	schreibeWTeilNichtAmUm((Kopf, TagesListe, ZeitenListe, Prio), Stream),
	bearbeiteWTeilNichtAmUm2(Rest, TagesListe, ZeitenListe, Prio,  Stream).

/***********************************************************/
/* schreibeWTeilNichtAmUm(+(Kopf, TagesListe, ZeitenListe, */
/*      Prio), +Stream)                                    */
/***********************************************************/
schreibeWTeilNichtAmUm((Kopf, TagesListe, ZeitenListe, Prio), Stream) :-
	print(Stream, 'veranstaltungNichtAmUmIn(\''),
	print(Stream, Kopf),
	print(Stream, '\', '),
	schreibeNormListe(Stream, TagesListe),
	print(Stream, ', '),
	schreibeNormListe(Stream, ZeitenListe),
	print(Stream, ', '),
	print(Stream, '_'),
	print(Stream, ', '),
	print(Stream, Prio),
	print(Stream, '). '),
	nl(Stream).

/***********************************************************/
/* bearbeiteWVerNichtAmUmIn(+Ausgabe)                      */
/***********************************************************/
bearbeiteWVerNichtAmUmIn(Ausgabe) :-
	compile(Ausgabe),
	findall((Name, TagesListe, ZeitenListe, Raum, Prio), 
	veranstaltungNichtAmUmIn(Name, TagesListe, ZeitenListe, Raum, Prio), Liste),
	schreibeVerMitZeitPrio(Liste, Ausgabe, 'veranstaltungNichtAmUmInW').

/***********************************************************/
/* bearbeiteWVerAmUmIn(+Ausgabe)                           */
/***********************************************************/
bearbeiteWVerAmUmIn(Ausgabe) :-
	findall((Name, TagesListe, ZeitenListe, Raum, Prio), veranstaltungAmUmIn(Name, TagesListe, ZeitenListe, Raum, Prio), Liste),
	schreibeVerMitZeitPrio(Liste, Ausgabe, 'veranstaltungAmUmInW').
   
/***********************************************************/
/* bearbeiteWVerNichtZusammenhaengend(+Ausgabe)            */
/***********************************************************/
bearbeiteWVerNichtZusammenhaengend(Ausgabe) :-
	findall((Name1, Name2, Prio), veranstaltungenNichtZusammenhaengend(Name1, Name2, Prio), Liste),
	schreibeZweiVerPrio(Liste, Ausgabe, 'veranstaltungenNichtZusammenhaengendW').

/***********************************************************/
/* bearbeiteWVerAmSelbenTag(+Ausgabe)                      */
/***********************************************************/
bearbeiteWVerAmSelbenTag(Ausgabe) :-
	findall((Name1, Name2, Prio), veranstaltungenAmSelbenTag(Name1, Name2, Prio), Liste),
	schreibeZweiVerPrio(Liste, Ausgabe, 'veranstaltungenAmSelbenTagW').

/***********************************************************/
/* Hilfspraedikate                                         */
/***********************************************************/

/***********************************************************/
/* schreibeTagesZeitenListe(+Liste, +Stream, +TagOderZeit) */
/***********************************************************/
/* schreibt eine Tages- oder Zeiten-liste um               */
/* Namen -> Nummern                                        */
/***********************************************************/
schreibeTagesZeitenListe(Element, Stream, _) :- 
	var(Element),
	print(Stream, '_'),
	!.
schreibeTagesZeitenListe(Liste, Stream, TagOderZeit) :-
	print(Stream, '['),
	schreibeTagesZeitenListe1(Liste, Stream, TagOderZeit),
	print(Stream, ']').

/***********************************************************/
/* schreibeTagesZeitenListe1(+Liste, +Stream, +TagOderZeit)*/
/***********************************************************/
schreibeTagesZeitenListe1([], _, _).
schreibeTagesZeitenListe1([Kopf], Stream, tage) :-
	tag(Nummer, Kopf, _),
	print(Stream, Nummer),
	!.
schreibeTagesZeitenListe1([Kopf|Rest], Stream, tage) :-
	tag(Nummer, Kopf, _),
	print(Stream, Nummer),
	print(Stream, ', '),
	schreibeTagesZeitenListe1(Rest, Stream, tage). 
schreibeTagesZeitenListe1([Kopf], Stream, zeiten) :-
	zeit(Nummer, Kopf, _),
	print(Stream, Nummer),
	!.
schreibeTagesZeitenListe1([Kopf|Rest], Stream, zeiten) :-
	zeit(Nummer, Kopf, _),
	print(Stream, Nummer),
	print(Stream, ', '),
	schreibeTagesZeitenListe1(Rest, Stream, zeiten). 

/***********************************************************/
/* schreibeRaumAlsZahl(+Raum, +Stream)                     */
/***********************************************************/
/* schreibt einen Raum um                                  */
/* Name -> Nummer                                          */
/***********************************************************/
schreibeRaumAlsZahl(Raum, Stream) :-
	var(Raum),
	print(Stream, '_').
schreibeRaumAlsZahl(Raum, Stream) :-
	not(var(Raum)),
	raum(Nummer, Raum, _, _, _),
	print(Stream, Nummer).

/***********************************************************/
/* schreibeNormListe(+Stream, +Liste)                      */
/***********************************************************/
/* schreibt eine Tages oder Zeitenliste normal             */
/* fuer die Umwandlung von teilnehmernichtamUm in          */
/* veranstaltungNichtamUmIn                                */
/***********************************************************/
schreibeNormListe(Stream, Element) :-
	var(Element),
	print(Stream, '_'),
	!.
schreibeNormListe(Stream, Element) :-
	not(var(Element)),
	writeq(Stream, Element).

/***********************************************************/
/* schreibeVerMitZeit(+Liste, +Ausgabe, +Text)             */
/***********************************************************/
schreibeVerMitZeit(Liste, Ausgabe, Text) :-    
	open(Ausgabe, append, Stream),
	schreibeVerMitZeit1(Liste, Stream, Text),
	close(Stream).

/***********************************************************/
/* schreibeVerMitZeit1(+Liste, +Ausgabe, +Text)            */
/***********************************************************/
schreibeVerMitZeit1([], Stream, Text) :-
	print(Stream, Text),
	print(Stream, '(_, _, _, _) :- false.'),
	nl(Stream),
	nl(Stream).   
schreibeVerMitZeit1([(Name, TagesListe, ZeitenListe, Raum)|Rest], Stream, Text) :-
	veranstaltung(Nummer, Name, _, _, _),
	print(Stream, Text),
	print(Stream, '('),
	print(Stream, Nummer),
	print(Stream, ', '),
	schreibeTagesZeitenListe(TagesListe, Stream, tage),
	print(Stream, ', '),
	schreibeTagesZeitenListe(ZeitenListe, Stream, zeiten),   
	print(Stream, ', '),
	schreibeRaumAlsZahl(Raum, Stream),
	print(Stream, '). '),
	nl(Stream),
	schreibeVerMitZeit1(Rest, Stream, Text).

/***********************************************************/
/* schreibeVerMitZeit(+Liste, +Ausgabe, +Text)             */
/***********************************************************/
schreibeVerMitZeitHilf(Liste, Ausgabe, Text) :-    
	open(Ausgabe, append, Stream),
	schreibeVerMitZeitHilf1(Liste, Stream, Text),
	close(Stream).

/***********************************************************/
/* schreibeVerMitZeit1(+Liste, +Ausgabe, +Text)            */
/***********************************************************/
schreibeVerMitZeitHilf1([(Name, TagesListe, ZeitenListe, Raum)], Stream, Text) :-
	veranstaltung(Nummer, Name, _, _, _),
	print(Stream, Text),
	print(Stream, '('),
	print(Stream, Nummer),
	print(Stream, ', '),
	schreibeTagesZeitenListe(TagesListe, Stream, tage),
	print(Stream, ', '),
	schreibeTagesZeitenListe(ZeitenListe, Stream, zeiten),   
	print(Stream, ', '),
	schreibeRaumAlsZahl(Raum, Stream),
	print(Stream, '). '),
	nl(Stream).

/***********************************************************/
/* schreibeVerMitPrio(+Liste, +Ausgabe, +Text)             */
/***********************************************************/
schreibeVerMitZeitPrio(Liste, Ausgabe, Text) :-    
	open(Ausgabe, append, Stream),
	schreibeVerMitZeitPrio1(Liste, Stream, Text),
	close(Stream).

/***********************************************************/
/* schreibeVerMitPrio1(+Liste, +Ausgabe, +Text)            */
/***********************************************************/
schreibeVerMitZeitPrio1([], Stream, Text) :-
	print(Stream, Text),
	print(Stream, '(_, _, _, _, _) :- false.'),
	nl(Stream),
	nl(Stream).   
schreibeVerMitZeitPrio1([(Name, TagesListe, ZeitenListe, Raum, Prio)|Rest], 
Stream, Text) :-
	veranstaltung(Nummer, Name, _, _, _),
	print(Stream, Text),
	print(Stream, '('),
	print(Stream, Nummer),
	print(Stream, ', '),
	schreibeTagesZeitenListe(TagesListe, Stream, tage),
	print(Stream, ', '),
	schreibeTagesZeitenListe(ZeitenListe, Stream, zeiten),   
	print(Stream, ', '),
	schreibeRaumAlsZahl(Raum, Stream),
	print(Stream, ', '),
	print(Stream, Prio),
	print(Stream, '). '),
	nl(Stream),
	schreibeVerMitZeitPrio1(Rest, Stream, Text).

/***********************************************************/
/* schreibeZweiVer(+Liste, +Ausgabe, +Text)                */
/***********************************************************/
/* schreibt Fakten bestehend aus zwei Veranstaltungsnamen  */
/* um: Namen -> Nummern                                    */
/***********************************************************/
schreibeZweiVer(Liste, Ausgabe, Text) :-
	open(Ausgabe, append, Stream),
	schreibeZweiVer1(Liste, Stream, Text),
	close(Stream).

/***********************************************************/
/* schreibeZweiVer1(+Liste, +Ausgabe, +Text)               */
/***********************************************************/
schreibeZweiVer1([], Stream, Text) :-
	print(Stream, Text),
	print(Stream, '(_, _) :- false.'),
	nl(Stream),
	nl(Stream).   
schreibeZweiVer1([(Name1, Name2)|Rest], Stream, Text) :-   
	veranstaltung(Nummer1, Name1, _, _, _),
	veranstaltung(Nummer2, Name2, _, _, _),
	print(Stream, Text),
	print(Stream, '('),
	print(Stream, Nummer1),
	print(Stream, ', '),
	print(Stream, Nummer2),
	print(Stream, '). '),
	nl(Stream),
	schreibeZweiVer1(Rest, Stream, Text).

/***********************************************************/
/* schreibeZweiVerPrio(+Liste, +Ausgabe, +Text)            */
/***********************************************************/
schreibeZweiVerPrio(Liste, Ausgabe, Text) :-
	open(Ausgabe, append, Stream),
	schreibeZweiVerPrio1(Liste, Stream, Text),
	close(Stream).

/***********************************************************/
/* schreibeZweiVerPrio1(+Liste, +Ausgabe, +Text)           */
/***********************************************************/
schreibeZweiVerPrio1([], Stream, Text) :-
	print(Stream, Text),
	print(Stream, '(_, _, _) :- false.'),
	nl(Stream),
	nl(Stream).   
schreibeZweiVerPrio1([(Name1, Name2, Prio)|Rest], Stream, Text) :-   
	veranstaltung(Nummer1, Name1, _, _, _),
	veranstaltung(Nummer2, Name2, _, _, _),
	print(Stream, Text),
	print(Stream, '('),
	print(Stream, Nummer1),
	print(Stream, ', '),
	print(Stream, Nummer2),
	print(Stream, ', '),
	print(Stream, Prio),
	print(Stream, '). '),
	nl(Stream),
	schreibeZweiVerPrio1(Rest, Stream, Text).

/***********************************************************/
/* findeGleicheTeilnehmerGruppen(+Ausgabedatei)            */
/***********************************************************/
/* Heraussuchen der Vorlesungen, die die gleichen          */
/* Teilnehmer aufweisen                                    */
/***********************************************************/
findeGleicheTeilnehmerGruppen(Ausgabe) :-
	compile(Ausgabe),
	findall(TeilN, teilnehmerN(TeilN, _), TeilNListe),
	findeGleicheTeilnehmerGruppen(TeilNListe, GlTeilnehmerListe),
	schreibeGleicheTeilnehmerGruppen(GlTeilnehmerListe, Ausgabe).

/***********************************************************/
/* findeGleicheTeilnehmerGruppen(+Teilnehmer,              */
/*      -GleicheTeilnehmer)                                */
/***********************************************************/
/* Beruecksichtigen von Untergruppen fuer z.B. Uebungen.   */
/* Veranstaltungen innerhalb einer Obergruppe duerfen      */
/* zu gleichen Zeiteinheiten stattfinden.                  */
/***********************************************************/
findeGleicheTeilnehmerGruppen([], []).
findeGleicheTeilnehmerGruppen([Kopf|Rest], VerRest) :-
	findall(VerNo, (veranstaltung(VerNo, _, Teilnehmer, _, _), (member(Kopf, Teilnehmer) ; (untergruppe(Kopf, _, GrName), member(GrName, Teilnehmer)) ; (untergruppe(Kopf, OGruppe, GrName), untergruppe(Kopf1, OGruppe1, GrName), 	OGruppe1 \== OGruppe, member(Kopf1, Teilnehmer)))), VerListe),
	(
	    length(VerListe, 0) 
	; 
	    length(VerListe, 1)
	),
	findeGleicheTeilnehmerGruppen(Rest, VerRest).
findeGleicheTeilnehmerGruppen([Kopf|Rest], VerRest) :-
	findall((Name, Gruppe), untergruppe(Name, Gruppe, _), Liste), 
	member((Kopf, Gruppe), Liste), 
	delete((Kopf, Gruppe), Liste, ListeDel), 
	Gruppe == Gruppe,	
	nonmember((Kopf1, Gruppe), ListeDel),
	Kopf \== Kopf1,
	findeGleicheTeilnehmerGruppen(Rest, VerRest).
findeGleicheTeilnehmerGruppen([Kopf|Rest], [VerListe|VerRest]) :-
	findall(VerNo, (veranstaltung(VerNo, _, Teilnehmer, _, _), (member(Kopf, Teilnehmer) ; (untergruppe(Kopf, _, GrName), member(GrName, Teilnehmer)) ; (untergruppe(Kopf, OGruppe, GrName), untergruppe(Kopf1, OGruppe1, GrName), OGruppe1 \== OGruppe, member(Kopf1, Teilnehmer)))), VerListe),
	findeGleicheTeilnehmerGruppen(Rest, VerRest).

/***********************************************************/
/* schreibeGleicheTeilnehmerGruppen(+GleicheTeilnehmer,    */
/*      +Ausgabedatei)                                     */
/***********************************************************/
/* Schreiben der Teilnehmergruppen in die Ausgabedatei     */
/***********************************************************/  
schreibeGleicheTeilnehmerGruppen(GlTeilnehmerListe,  Ausgabe) :-
	open(Ausgabe, append, Stream),
	schreibeGleicheTeilnehmerGruppen1(GlTeilnehmerListe, Stream),  
	close(Stream).  

/***********************************************************/
/* schreibeGleicheTeilnehmerGruppen1(+GleicheTeilnehmer,   */
/*      +Ausgabedatei)                                     */
/***********************************************************/
schreibeGleicheTeilnehmerGruppen1([], Stream) :-
	print(Stream, 'gleicheTeilnehmer(_) :- false.'),
	nl(Stream),
	nl(Stream).
schreibeGleicheTeilnehmerGruppen1([Kopf|Rest], Stream) :-
	print(Stream, 'gleicheTeilnehmer('),
	writeq(Stream, Kopf),
	print(Stream, ').'),
	nl(Stream),
	schreibeGleicheTeilnehmerGruppen1(Rest, Stream).  

/***********************************************************/
/* erstelleArray(?Array)                                   */
/***********************************************************/
/* Aufbereitung des Arrays, mit dem in allen weiteren      */
/* Stufen gearbeitet wird                                  */
/***********************************************************/
erstelleArray(Stundenplan) :-
	anzTage(AnzTage),
	anzZeiten(AnzZeiten),
	anzRaeume(AnzRaeume),
	anzVeranst(AnzVeranst),
	einStundenplan(Stundenplan),
	erstelleArray(AnzVeranst, AnzRaeume, AnzTage, AnzZeiten, Stundenplan).

/***********************************************************/
/* erstelleArray(+Index, +AnzRaeume, +AnzTage, +AnzZeiten, */
/*      -Array)                                            */
/***********************************************************/
/* Zuweisung der Anzahlen zu den einzelnen Dimensionen     */
/***********************************************************/
erstelleArray(0, _, _, _, _).
erstelleArray(AnzahlAct, AnzRaeume, AnzTage, AnzZeiten, Stundenplan) :-
	subscript(Stundenplan, [AnzahlAct, 1], Raum),
	Raum :: 1..AnzRaeume,
	subscript(Stundenplan, [AnzahlAct, 2], Tag), 
	Tag :: 1..AnzTage, 
	subscript(Stundenplan, [AnzahlAct, 3], Zeit),
	Zeit :: 1..AnzZeiten,
	AnzahlNeu is AnzahlAct - 1,
	erstelleArray(AnzahlNeu, AnzRaeume, AnzTage, AnzZeiten, Stundenplan).

/***********************************************************/
/* teilnehmerAnzahl(+Teilnehmer, -SummeDerTeilnehmer)      */
/***********************************************************/
/* Berechnen der Zuhoererzahl einer Veranstaltung          */
/* Endrekursion                                            */
/***********************************************************/
teilnehmerAnzahl(Teilnehmer, Anzahl) :-
	teilnehmerAnzahl1(Teilnehmer, 0, Anzahl).

/***********************************************************/
/* teilnehmerAnzahl1(+Teilnehmer, -SummeDerTeilnehmer)     */
/***********************************************************/
teilnehmerAnzahl1([], Anzahl, Anzahl).
teilnehmerAnzahl1([Kopf|Rest], AnzahlAkt, Anzahl) :-
	teilnehmerN(Kopf, AnzahlKopf),
	NeueAnzahl is AnzahlAkt + AnzahlKopf,
	teilnehmerAnzahl1(Rest, NeueAnzahl, Anzahl).

/***********************************************************/
/* schreibeNumListe(+Liste, +Ausgabedatei)                 */
/***********************************************************/
/* Schreiben einer numerierten Liste (zur Indizierung)     */
/***********************************************************/
schreibeNumListe(Liste, Ausgabe) :-
	open(Ausgabe, append, Stream),
	schreibeNumListe(Liste, 0, Stream),  
	close(Stream).

/***********************************************************/
/* schreibeNumListe1(+Liste, +Ausgabedatei)                */
/***********************************************************/
schreibeNumListe1(Liste, Ausgabe, ZurGleichenZeitListe) :-
 	open(Ausgabe, append, Stream),
	schreibeNumListe(Liste, 0, Stream, ZurGleichenZeitListe),  
	close(Stream).

/***********************************************************/
/* schreibeNumListe(+Liste, +Ausgabedatei, +Zaehler)       */
/***********************************************************/
/* Schreiben der nummerierten Raeume, Tage, Zeiten und     */
/* Veranstaltungen in die Ausgabedatei                     */
/***********************************************************/
schreibeNumListe([], _, Stream) :- 
	nl(Stream).
schreibeNumListe([raum(Raumname, Groesse, Ressourcen, Kosten)|Rest], NumOld, 
	Stream) :-
	Num is NumOld + 1,
	print(Stream, 'raum('),
	print(Stream, Num),
	print(Stream, ', '),
	writeq(Stream, (Raumname, Groesse, Ressourcen, Kosten)),
	print(Stream, ').'),
	nl(Stream),
	schreibeNumListe(Rest, Num, Stream).
schreibeNumListe([tag(Tagname, TagKosten)|Rest],  NumOld, Stream) :-
	Num is NumOld + 1,
	print(Stream, 'tag('),
	print(Stream, Num),
	print(Stream, ', '),
	writeq(Stream, (Tagname, TagKosten)),
	print(Stream, ').'),
	nl(Stream),
	schreibeNumListe(Rest, Num, Stream).
schreibeNumListe([zeit(Zeitname, ZeitKosten)|Rest], NumOld, Stream) :-
	Num is NumOld + 1,
	print(Stream, 'zeit('),
	print(Stream, Num),
	print(Stream, ', '),
	writeq(Stream, (Zeitname, ZeitKosten)),
	print(Stream, ').'),
	nl(Stream),
	schreibeNumListe(Rest, Num, Stream).

/***********************************************************/
/* schreibeNumListe(+Liste, +Zaehler, +Ausgabedatei,       */
/*      ?Liste)                                            */
/***********************************************************/
/* Schreiben der nummerierten Raeume, Tage, Zeiten und     */
/* Veranstaltungen in die Ausgabedatei                     */
/***********************************************************/
schreibeNumListe([], _, Stream, []) :- 
	nl(Stream).
schreibeNumListe([veranstaltung(VerName, VerTeil, VerRes)|Rest], NumOld, Stream, [ZurGleichenZeitListe|ZGLZRest]) :-
	Num is NumOld + 1,
	berechneTeilnehmerAnzahl(VerRes, VerTeil, TeilAnz),
        member(und(Raeume), VerRes), 
        Raeume = [Raumkopf|RaumRest],
        baueNeueVeranstaltungen(RaumRest, VerName, 1, NeueVeranstaltungen),
        baueZurGleichenZeitListe(Num, Raeume, ZurGleichenZeitListe),
        append(NeueVeranstaltungen, Rest, RestNeu), 
	print(Stream, 'veranstaltung('),
	print(Stream, Num),
	print(Stream, ', '),
	writeq(Stream, (VerName, VerTeil, Raumkopf, TeilAnz)),
	print(Stream, ').'),
	nl(Stream),
	schreibeNumListe(RestNeu, Num, Stream, ZGLZRest).
schreibeNumListe([veranstaltung(VerName, VerTeil, VerRes)|Rest], NumOld, Stream, ZurGleichenZeitListe) :-
	Num is NumOld + 1,
	berechneTeilnehmerAnzahl(VerRes, VerTeil, TeilAnz),
        not(member(und(_), VerRes)), 
	print(Stream, 'veranstaltung('),
	print(Stream, Num),
	print(Stream, ', '),
	writeq(Stream, (VerName, VerTeil, VerRes, TeilAnz)),
	print(Stream, ').'),
	nl(Stream),
	schreibeNumListe(Rest, Num, Stream, ZurGleichenZeitListe).

/***********************************************************/
/* baueNeueVeranstaltungen(+Liste, +VerName, +Num,         */
/*      -Ergebnis)                                         */
/***********************************************************/
/* Einfuegen von Dummy-Veranstaltungen.                    */
/* Wird benoetigt, wenn eine Veranstaltung zur gleichen    */
/* Zeit zwei (oder mehr) Raeume belegt.                    */
/***********************************************************/
baueNeueVeranstaltungen([], _,  _, []).
baueNeueVeranstaltungen([Kopf|Rest], VerName, Num, [veranstaltung(VerNameNeu, [], [Kopf])|VerRest]) :- 
        integer_atom(Num, NummernString),
        concat_atoms(' Dummy ', NummernString, DummyString), 
        concat_atoms(VerName, DummyString, VerNameNeu),
        NeuNum is Num + 1, 
        baueNeueVeranstaltungen(Rest, VerName, NeuNum, VerRest).

/***********************************************************/
/* baueZurGleichenZeitListe(+Num, +Liste, -Ergebnis)       */
/***********************************************************/
baueZurGleichenZeitListe(_, [], []).
baueZurGleichenZeitListe(Num, [_|Rest], [Num|ErgRest]) :-
        NeuNum is Num + 1,
        baueZurGleichenZeitListe(NeuNum, Rest, ErgRest).

/***********************************************************/
/* berechneTeilnehmerAnzahl(+Liste, +TeilnehmerListe,      */
/*     -Ergebnis)                                          */
/***********************************************************/
/* Berechnen der Anzahl der Veranstaltungsteilnehmer.  Ist */
/* ein fester Raum gegeben, wird die Anzahl mit 0          */
/* angegeben.                                              */
/***********************************************************/
berechneTeilnehmerAnzahl(Liste, VerTeil, Ergebnis) :-
	erstelleRaumListe(RaumListe),
	festerRaumGegeben(Liste, RaumListe, VerTeil, Ergebnis).

/***********************************************************/
/* festerRaumGegeben(+Liste, +RaumListe, +TeilnehmerListe, */
/*	-Ergebnis)                                         */
/***********************************************************/
festerRaumGegeben([], _, VerTeil, Ergebnis) :- 
	teilnehmerAnzahl(VerTeil, Ergebnis).
festerRaumGegeben(Liste, RaumListe, _, Ergebnis) :-
        % wenn oder vorhanden, dann auch Raum gegeben,
	% trotzdem wird nochmal die Zugehoerigkeit zu 
	% Raeumen getestet
	member(oder(Raeume), Liste),
	istTeilmenge(Raeume, RaumListe),
	Ergebnis is 0.
festerRaumGegeben([Kopf|_], RaumListe, _, Ergebnis) :-
        % Raum gefunden
	member(Kopf, RaumListe),
	Ergebnis is 0.
festerRaumGegeben([Kopf|Rest], RaumListe, VerTeil, Ergebnis) :-
        % Element nicht gefunden
	nonmember(Kopf, RaumListe),
	festerRaumGegeben(Rest, RaumListe, VerTeil, Ergebnis).

















